/*
   DISCLAIMER: This package was written by Rudi Demeulenaere, so
   do not blable me for bugs :) Report them to me anyways, I'll fix
   them.
   		Ilya.
*/

set define off
create or replace
package HTF as

-----------     PRINT FUNCTIONS
function print( cbuf IN VARCHAR2 ) return VARCHAR2;
function p( cbuf IN VARCHAR2 ) return VARCHAR2;
function prn( cbuf IN VARCHAR2 ) return VARCHAR2;
function prints( cbuf IN VARCHAR2 ) return VARCHAR2;
function ps( cbuf IN VARCHAR2 ) return VARCHAR2;
function escape_sc(ctext IN VARCHAR2) return VARCHAR2;
function escape_url(ctext IN VARCHAR2) return VARCHAR2;
-----------

-----------     STRUCTURE TAGS
function htmlOpen return VARCHAR2;
function htmlClose return VARCHAR2;
function headOpen return VARCHAR2;
function headClose return VARCHAR2;
function bodyOpen( cbackground IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function bodyClose return VARCHAR2;
-----------

-----------     HEAD RELATED TAGS
function title( ctitle IN VARCHAR2 ) return VARCHAR2;
function base( ctarget IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function isindex( cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL )
  return VARCHAR2;
function linkRel( crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL )
  return VARCHAR2;
function linkRev( crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL )
  return VARCHAR2;
function meta( chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2 )
  return VARCHAR2;
function nextid(cidentifier IN VARCHAR2) return VARCHAR2;
function style(cstyle IN VARCHAR2) return VARCHAR2;
function script(cscript IN VARCHAR2, clanguage IN VARCHAR2 default NULL) return VARCHAR2;
-----------

-----------     BODY TAGS
function line( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function hr( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function nl( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL )
  return VARCHAR2;
function br( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL )
  return VARCHAR2;
function header( nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function htitle(ctitle IN VARCHAR2, nsize in integer default 1,
  calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function anchor( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function anchor2( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function mailto( caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function img( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function img2( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function para return VARCHAR2;
function paragraph( calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function address( cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function Comment( ctext IN VARCHAR2 ) return VARCHAR2;
function preOpen( cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function preClose return VARCHAR2;
function blockquoteOpen( cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function blockquoteClose return VARCHAR2;
function area( ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL,
  chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function mapOpen( cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function mapClose return VARCHAR2;
function bgsound( csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function div( calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL )
  return VARCHAR2;
function listingOpen return VARCHAR2;
function listingClose return VARCHAR2;
function nobr( ctext IN VARCHAR2 ) return VARCHAR2;
function wbr return VARCHAR2;
function center( ctext IN VARCHAR2 ) return VARCHAR2;
function centerOpen return VARCHAR2;
function centerClose return VARCHAR2;
function dfn(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function big( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function small( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function sub( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function sup( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function baseFont(nsize IN INTEGER, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function fontOpen( ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function fontClose return VARCHAR2;
function plaintext( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function s( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function strike( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function format_cell(columnValue IN VARCHAR2, format_numbers IN VARCHAR2 default NULL)
  return VARCHAR2;
function param(cname IN VARCHAR2, cvalue IN VARCHAR2 default NULL) return VARCHAR2;

--------- FRAME TAGS
function framesetOpen( crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function framesetClose return VARCHAR2;
function frame( csrc IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL,
  cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function noframeOpen return VARCHAR2;
function noframeClose return VARCHAR2;

--------- LIST TAGS
function listHeader( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL )
  return VARCHAR2;
function listItem( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function ulistOpen( cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function ulistClose return VARCHAR2;
function olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function olistClose return VARCHAR2;
function dlistOpen( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL )
  return VARCHAR2;
function dlistClose return VARCHAR2;
function dlistDef( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function menulistOpen return VARCHAR2;
function menulistClose return VARCHAR2;
function dirlistOpen return VARCHAR2;
function dirlistClose return VARCHAR2;

---------	CHARACTER FORMAT TAGS
function cite( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function code( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function emphasis( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function em( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function keyboard( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function kbd( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function sample( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function strong( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function variable( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;

---------	PHYSICAL FORMAT TAGS
function bold( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function italic( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;
function underline(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function teletype( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL ) return VARCHAR2;

---------	FORM TAGS
function formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST',
  ctarget IN VARCHAR2 default NULL, cenctype IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formClose return VARCHAR2;
function formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON',
  cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formFile(cname IN VARCHAR2, caccept IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formPassword(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2, cchecked IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formReset(cvalue IN VARCHAR2 default 'Reset', cattributes IN VARCHAR2 default NULL)
  return VARCHAR2;
function formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'Submit',
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formSelectOpen(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formSelectClose return VARCHAR2;
function formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function formTextAreaClose return VARCHAR2;

---------	TABLE TAGS
function tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function tableClose return VARCHAR2;
function tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function tableRowClose return VARCHAR2;
function tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;
function tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2;

end HTF;
/
create or replace
package body HTF AS

defaultBorder varchar2(20):=null;
--defaultBorder varchar2(20):=' BORDER=1';
-- for tables, (ab)used for "layout debugging"

function ifnotnull(cnull varchar2, cresult varchar2) return varchar2 is
begin
	if cnull is null then
		return null;
	end if;
	return cresult;
end;

-----------	PRINT PROCEDURES
function print(cbuf IN VARCHAR2) return VARCHAR2 IS
begin
	return cbuf||CHR(13) ;
end print;

function p(cbuf IN VARCHAR2) return VARCHAR2 IS
begin
	return cbuf||CHR(13);
end p;

function prn(cbuf IN VARCHAR2) return VARCHAR2 IS
begin
	return cbuf;
end prn;

function escape_sc(ctext IN VARCHAR2) return VARCHAR2 IS
begin
	return  replace( replace( replace( replace(ctext
	  ,'&','&amp;'),'<','&lt;'),'>','&gt;'), '"', '&quot;') ;
end;

function escape_url(ctext IN VARCHAR2) return VARCHAR2 IS
begin
	return replace(escape_sc(ctext),'%','%25');
end;

function prints(cbuf IN VARCHAR2) return VARCHAR2 IS
begin
	return escape_sc(cbuf);
end prints;

function ps(cbuf IN VARCHAR2) return VARCHAR2 IS
begin
	return escape_sc(cbuf);
end ps;
-----------

-----------	 STRUCTURE TAGS
function htmlOpen return VARCHAR2 IS
begin
	return p('<HTML>');
end htmlOpen;

function htmlClose return VARCHAR2 IS
begin
	return p('</HTML>');
end htmlClose;

function headOpen return VARCHAR2 IS
begin
	return p('<HEAD>');
end headOpen;

function headClose return VARCHAR2 IS
begin
	return p('</HEAD>');
end headClose;

function bodyOpen(cbackground IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<BODY'||
	  ifnotnull(cbackground,' background="'||cbackground||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end bodyOpen;

function bodyClose return VARCHAR2 IS
begin
	return p('</BODY>');
end bodyClose;
----------

----------	HEAD RELATED TAGS
function title(ctitle IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<TITLE>'||ctitle||'</TITLE>');
end title;

function base(ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<BASE'||
	  ifnotnull(ctarget,' TARGET="'||ctarget||'"')||
	  ifnotnull(cattributes,' '||cattributes||'"')||
	  ' HREF="'||owa_util.get_cgi_env('SERVER_NAME')||':'||
	             owa_util.get_cgi_env('SERVER_PORT')||
	             owa_util.get_cgi_env('SCRIPT_NAME')||
	             owa_util.get_cgi_env('PATH_INFO')||
	  '"'||
	  '>');
	  -- not fully compliant yet
end base;

function ISindex(cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<ISINDEX'||
	  ifnotnull(cprompt,' PROMPT="'||cprompt||'"')||
	  ifnotnull(curl,' HREF="'||curl)||
	  '">');
end ISindex;

function linkRel(crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<LINK REL="'||crel||'" HREF="'||curl||'"'||
	  ifnotnull(ctitle,' TITLE="'||ctitle)||
	  '">');
end linkRel;

function linkRev(crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<LINK REV="'||crev||'" HREF="'||curl||'"'||
	  ifnotnull(ctitle,' TITLE="'||ctitle)||
	  '">');
end linkRev;

function meta(chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2)
  return VARCHAR2 IS
begin
	return p('<META HTTP-EQUIV="'||chttp_equiv||'" NAME="'||cname||'" CONTENT="'||ccontent||'">');
end meta;

function nextid(cidentifier IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<NEXTID N="'||cidentifier||
	'>');
end;

function style(cstyle IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<STYLE>'||cstyle||'</STYLE>');
end;

function script(cscript IN VARCHAR2, clanguage IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<SCRIPT'||
	  ifnotnull(clanguage,' LANGUAGE='''||clanguage||'''')||
	  '>'||cscript||'</SCRIPT>');
end;

--------	 BODY TAGS
function line(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return hr(cclear,csrc,cattributes);
end line;

function hr(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<HR'||
	  ifnotnull(cclear,     ' CLEAR="'||cclear||'"')||
	  ifnotnull(csrc,       ' SRC="'||csrc||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end hr;

function nl(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return br(cclear,cattributes);
end nl;

function br(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<BR'||
	  ifnotnull(cclear,     ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end br;

function header(nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<H'||nsize||
	  ifnotnull(calign,     ' ALIGN="'||calign||'"')||
	  ifnotnull(cnowrap,    ' NOWRAP')||
	  ifnotnull(cclear,     ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||cheader||'</H'||nsize||'>');
end header;

function htitle(ctitle IN VARCHAR2, nsize in integer default 1,
  calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
  return title(ctitle)||
    header(nsize,ctitle,calign,cnowrap,cclear,cattributes);
end;

function anchor(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return anchor2(curl,ctext,cname,NULL,cattributes);
end anchor;

function anchor2(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<A HREF="'||curl||'"'||
	  ifnotnull(cname,      ' NAME="'||cname||'"')||
	  ifnotnull(ctarget,    ' TARGET="'||ctarget||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</A>');
end anchor2;

function mailto(caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<A HREF="mailto:'||caddress||'"'||
	  ifnotnull(cname,      ' NAME="'||cname||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</A>');
end mailto;

function img(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
  return img2(curl,calign,calt,cismap,NULL,cattributes);
end img;

function img2(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<IMG SRC="'||curl||'"'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(calt,        ' ALT="'||calt||'"')||
	  ifnotnull(cismap,      ' ISMAP')||
	  ifnotnull(cusemap,     ' USEMAP="'||cusemap||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end img2;

function para return VARCHAR2 IS
begin
	return '<P>';
end para;

function paragraph(calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<P'||
	  ifnotnull(calign,      ' CALIGN='||calign)||
	  ifnotnull(cnowrap,     ' NOWRAP')||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end paragraph;

function address(cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<ADDRESS'||
	  ifnotnull(cnowrap,     ' NOWRAP')||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||cvalue||'</ADDRESS>');
end address;

function Comment(ctext IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<!-- '||ctext||' -->');
end Comment;

function preOpen(cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<PRE'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cwidth,      ' WIDTH='||cwidth)||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end preOpen;

function preClose return VARCHAR2 IS
begin
	return p('</PRE>');
end preClose;

function blockquoteOpen(cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<BLOCKQUOTE'||
	  ifnotnull(cclear, ' CLEAR="'||cclear||'"')||
	  ifnotnull(cnowrap,' NOWRAP')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end blockquoteOpen;

function blockquoteClose return VARCHAR2 IS
begin
	return p('</BLOCKQUOTE>');
end blockquoteClose;

function area(ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL,
  chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<AREA COORDS="'||ccoords||'"'||
	  ifnotnull(cshape,      ' SHAPE="'||cshape||'"')||
	  ifnotnull(chref,       ' HREF="'||chref||'"')||
	  ifnotnull(cnohref,     ' NOHREF')||
	  ifnotnull(ctarget,     ' TARGET="'||ctarget||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end area;

function mapOpen(cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<MAP NAME="'||cname||'"'||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end mapOpen;

function mapClose return VARCHAR2 IS
begin
	return p('</MAP>');
end mapClose;

function bgsound(csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<BGSOUND SRC="'||csrc||'"'||
	  ifnotnull(cloop,       ' LOOP="'||cloop||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end bgsound;

function div(calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<DIV'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end div;

function listingOpen return VARCHAR2 IS
begin
	return p('<LISTING>');
end listingOpen;

function listingClose return VARCHAR2 IS
begin
	return p('</LISTING>');
end listingClose;

function nobr(ctext IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<NOBR>'||ctext||'</NOBR>');
end nobr;

function wbr return VARCHAR2 IS
begin
	return '<WBR>';
end wbr;

function center(ctext IN VARCHAR2) return VARCHAR2 IS
begin
	return p('<CENTER>'||ctext||'</CENTER>');
end center;

function centerOpen return VARCHAR2 IS
begin
	return '<CENTER>';
end centerOpen;

function centerClose return VARCHAR2 IS
begin
	return p('</CENTER>');
end centerClose;

function dfn(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<DFN'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</DFN>');
end dfn;

function big(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<BIG'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</BIG>');
end big;

function small(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<SMALL'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</SMALL>');
end small;

function sub(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<SUB'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</SUB>');
end sub;

function sup(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<SUP'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</SUP>');
end sup;

function baseFont(nsize IN INTEGER, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<BASEFONT SIZE="'||nsize||'"'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end baseFont;

function fontOpen(ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<FONT'||
	  ifnotnull(ccolor,      ' COLOR="'||ccolor||'"')||
	  ifnotnull(cface,       ' FACE="'||cface||'"')||
	  ifnotnull(nsize,       ' SIZE="'||nsize||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end fontOpen;

function fontClose return VARCHAR2 IS
begin
	return p('</FONT>');
end fontClose;

function plaintext(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<PLAINTEXT'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</PLAINTEXT>');
end plaintext;

function s(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<S'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</S>');
end s;

function strike(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<STRIKE'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</STRIKE>');
end strike;

function param(cname IN VARCHAR2, cvalue IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<PARAM NAME="'||cname||
	  ifnotnull(cvalue, ' VALUE="'||cvalue||'"')||
	  '>');
end param;

function appletOpen(ccode IN VARCHAR2, cwidth	IN INTEGER, cheight	IN INTEGER,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 is
begin
  return p('<APPLET CODE="'||ccode||'"'||
	  ifnotnull(cwidth,      ' WIDTH="'||cwidth||'"')||
	  ifnotnull(cheight,     ' HEIGHT="'||cheight||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
		'>');
end;

function format_cell(columnValue IN VARCHAR2, format_numbers IN VARCHAR2 default NULL)
  return VARCHAR2 is
  dummy    number;
  function tochar(d in number, f in varchar2) return varchar2 is
  begin
    return nvl(ltrim(to_char(d,f)), '(null)');
  end tochar;
begin
  if (format_numbers is NULL) then
    return(tableData(columnValue));
  end if;
  dummy := to_number(columnValue);
  if (trunc(dummy) = dummy) then
    return(tableData(tochar(dummy,'999,999,999,999'), 'right'));
  else
    return(tableData(tochar(dummy,'999,999,990.99'), 'right'));
  end if;
exception
  when others then
    return(tableData(nvl(columnValue, '(null)')));
end format_cell;

---------------

---------------	FRAME TAGS
function framesetOpen(crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<FRAMESET'||
	  ifnotnull(crows,       ' ROWS="'||crows||'"')||
	  ifnotnull(ccols,       ' COLS="'||ccols||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end framesetOpen;

function framesetClose return VARCHAR2 IS
begin
	return p('</FRAMESET>');
end framesetClose;

function frame(csrc IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL,
  cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<FRAME'||
	  ifnotnull(csrc,          ' SRC="'||csrc||'"')||
	  ifnotnull(cname,         ' NAME="'||cname||'"')||
	  ifnotnull(cmarginwidth,  ' MARGINWIDTH="'||cmarginwidth||'"')||
	  ifnotnull(cmarginheight, ' MARGINHEIGHT="'||cmarginheight||'"')||
	  ifnotnull(cscrolling,    ' SCROLLING="'||cscrolling||'"')||
	  ifnotnull(cnoresize,     ' NORESIZE')||
	  ifnotnull(cattributes,   ' '||cattributes)||
	  '>');
end frame;

function noframeOpen return VARCHAR2 IS
begin
	return p('<NOFRAMES>');
end noframeOpen;

function noframeClose return VARCHAR2 IS
begin
	return p('</NOFRAMES>');
end noframeClose;
-----------------

-----------------	LIST TAGS
function listHeader(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<LH'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</LH>');
end listHeader;

function listItem(ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<LI'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cdingbat,    ' DINGBAT="'||cdingbat||'"')||
	  ifnotnull(csrc,        ' SCR="'||csrc||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext);
end listItem;

function ulistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<UL'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cwrap,       ' WRAP="'||cwrap||'"')||
	  ifnotnull(cdingbat,    ' DINGBAT="'||cdingbat||'"')||
	  ifnotnull(csrc,        ' SRC="'||csrc||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end ulistOpen;

function ulistClose return VARCHAR2 IS
begin
	return p('</UL>');
end ulistClose;

function olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<OL'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cwrap,       ' WRAP="'||cwrap||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end olistOpen;

function olistClose return VARCHAR2 IS
begin
	return p('</OL>');
end olistClose;

function dlistOpen(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<DL'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end dlistOpen;

function dlistClose return VARCHAR2 IS
begin
	return p('</DL>');
end dlistClose;

function dlistDef(ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<DD'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext);
end dlistDef;

function dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<DT'||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext);
end dlistTerm;

function menulistOpen return VARCHAR2 IS
begin
	return p('<MENU>');
end menulistOpen;

function menulistClose return VARCHAR2 IS
begin
	return p('</MENU>');
end menulistClose;

function dirlistOpen return VARCHAR2 IS
begin
	return p('<DIR>');
end dirlistOpen;

function dirlistClose return VARCHAR2 IS
begin
	return p('</DIR>');
end dirlistClose;

---------	CHARACTER FORMAT TAGS
function cite(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<CITE'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</CITE>');
end cite;

function code(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<CODE'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</CODE>');
end code;

function emphasis(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return em(ctext,cattributes);
end emphasis;

function em(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<EM'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</EM>');
end em;

function keyboard(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return kbd(ctext,cattributes);
end keyboard;

function kbd(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<KBD'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</KBD>');
end kbd;

function sample(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<SAMP'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</SAMP>');
end sample;

function strong(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<STRONG'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</STRONG>');
end strong;

function variable(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<VAR'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ctext||'</VAR>');
end variable;
---------

---------	PHYSICAL FORMAT TAGS
function bold(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<B'||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</B>';
end bold;

function italic(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<I'||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</I>';
end italic;

function underline(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<U'||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</U>';
end underline;

function teletype(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<TT'||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||ctext||'</TT>';
end teletype;

---------	FORM TAGS
function formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST',
  ctarget IN VARCHAR2 default NULL, cenctype IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<FORM'||
	  ifnotnull(curl,       ' ACTION="'||curl||'"')||
	  ifnotnull(cmethod,    ' METHOD="'||cmethod||'"')||
	  ifnotnull(ctarget,    ' TARGET="'||ctarget||'"')||
	  ifnotnull(cenctype,   ' ENCTYPE="'||cenctype||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end formOpen;

function formClose return VARCHAR2 IS
begin
	return p('</FORM>');
end formClose;

function formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON',
  cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="checkbox" NAME="'||cname||'"'||
	  ifnotnull(cvalue,      ' VALUE="'||cvalue||'"')||
	  ifnotnull(cchecked,    ' CHECKED')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formCheckBox;

function formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default null,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="hidden" NAME="'||cname||'" VALUE="'||cvalue||'"'||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formHidden;

function formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="image" NAME="'||cname||'" SRC="'||csrc||'"'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formImage;

function formFile(cname IN VARCHAR2, caccept IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="file" NAME="'||cname||'"'||
	  ifnotnull(caccept,     ' ACCEPT="'||caccept||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formFile;

function formPassword(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="password" NAME="'||cname||'"'||
	  ifnotnull(csize,       ' SIZE="'||csize||'"')||
	  ifnotnull(cmaxlength,  ' MAXLENGTH="'||cmaxlength||'"')||
	  ifnotnull(cvalue,      ' VALUE="'||cvalue||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formPassword;

function formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2, cchecked IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="radio" NAME="'||cname||'" VALUE="'||cvalue||'"'||
	  ifnotnull(cchecked,    ' CHECKED')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formRadio;

function formReset(cvalue IN VARCHAR2 default 'Reset', cattributes IN VARCHAR2 default NULL)
  return VARCHAR2 IS
begin
	return p('<INPUT TYPE="reset"'||
	  ifnotnull(cvalue,      ' VALUE="'||cvalue||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formReset;

function formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'Submit',
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="submit"'||
	  ifnotnull(cname,       ' NAME="'||cname||'"')||
	  ifnotnull(cvalue,      ' VALUE="'||cvalue||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formSubmit;

function formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<INPUT TYPE="text"'||
	  ifnotnull(cname,       ' NAME="'||cname||'"')||
	  ifnotnull(cvalue,      ' VALUE="'||cvalue||'"')||
	  ifnotnull(csize,       ' SIZE="'||csize||'"')||
	  ifnotnull(cmaxlength,  ' MAXLENGTH="'||cmaxlength||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
end formText;

function formSelectOpen(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
  return p('<SELECT NAME="'||cname||'"'||
	  ifnotnull(cprompt,    ' PROMPT="'||cprompt||'"')||
	  ifnotnull(nsize,      ' SIZE="'||nsize||'"')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end formSelectOpen;

function formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<OPTION'||
	  ifnotnull(cselected,  ' SELECTED')||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||cvalue);
end formSelectOption;

function formSelectClose return VARCHAR2 IS
begin
	return p('</SELECT>');
end formSelectClose;

function formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return formTextArea2(cname,nrows,ncolumns,calign,NULL,cattributes);
end formTextArea;

function formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return formTextAreaOpen2(cname,nrows,ncolumns,calign,cwrap,cattributes)||
	  formTextAreaClose;
end formTextArea2;

function formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return formTextAreaOpen2(cname,nrows,ncolumns,calign,NULL,cattributes);
end formTextAreaOpen;

function formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<TEXTAREA NAME="'||cname||'"'||
	  ifnotnull(nrows,       ' ROWS="'||nrows||'"')||
	  ifnotnull(ncolumns,    ' COLS="'||ncolumns||'"')||
	  ifnotnull(cwrap,       ' WRAP="'||cwrap||'"')||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>';
end formTextAreaOpen2;

function formTextAreaClose return VARCHAR2 IS
begin
	return p('</TEXTAREA>');
end formTextAreaClose;

--------- 	TABLE TAGS
function tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<TABLE'||
	  nvl(ifnotnull(cborder, ' '||cborder),defaultBorder)||
	  ifnotnull(cnowrap,     ' NOWRAP')||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cclear,      ' CLEAR="'||cclear||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>');
-- it would seem more logic to use TABLE BORDER='||cborder
-- but this complies to the somewhat odd default Oracle choice
end tableOpen;

function tableClose return VARCHAR2 IS
begin
	return p('</TABLE>');
end tableCLose;

function tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return '<CAPTION'||
	  ifnotnull(calign,      ' ALIGN="'||calign||'"')||
	  ifnotnull(cattributes, ' '||cattributes)||
	  '>'||ccaption||'</CAPTION>';
end tableCaption;

function tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 IS
begin
	return p('<TR'||
	  ifnotnull(calign,  ' ALIGN="'||calign||'"')||
	  ifnotnull(cvalign, ' VALIGN="'||cvalign||'"')||
	  ifnotnull(cdp,     ' DP="'||cdp||'"')||
	  ifnotnull(cnowrap, ' '||cnowrap)||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>');
end tableRowOpen;

function tableRowClose return VARCHAR2 IS
begin
	return p('</TR>');
end tableRowClose;

function tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 is
begin
	return p('<TH'||
	  ifnotnull(calign,  'ALIGN="'||calign||'"')||
	  ifnotnull(cdp,     ' DP="'||cdp||'"')||
	  ifnotnull(crowspan,' ROWSPAN="'||crowspan||'"')||
	  ifnotnull(ccolspan,' COLSPAN="'||ccolspan||'"')||
	  ifnotnull(cnowrap, ' '||cnowrap)||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||cvalue||'</TH>');
end tableHeader;

function tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) return VARCHAR2 is
begin
	return p('<TD'||
	  ifnotnull(calign,  ' ALIGN="'||calign||'"')||
	  ifnotnull(cdp,     ' DP="'||cdp||'"')||
	  ifnotnull(crowspan,' ROWSPAN="'||crowspan||'"')||
	  ifnotnull(ccolspan,' COLSPAN="'||ccolspan||'"')||
	  ifnotnull(cnowrap, ' '||cnowrap)||
	  ifnotnull(cattributes,' '||cattributes)||
	  '>'||cvalue||'</TD>');
end tableData;

end HTF;
/
create or replace
package HTP as

-----------     PRINT PROCEDURES
procedure print( cbuf IN VARCHAR2 );
procedure p( cbuf IN VARCHAR2 );
procedure prn( cbuf IN VARCHAR2 );
procedure prints( cbuf IN VARCHAR2 );
procedure ps( cbuf IN VARCHAR2 );
-----------

-----------     STRUCTURE TAGS
procedure htmlOpen;
procedure htmlClose;
procedure headOpen;
procedure headClose;
procedure bodyOpen( cbackground IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure bodyClose;
-----------

-----------     HEAD RELATED TAGS
procedure title( ctitle IN VARCHAR2 );
procedure base( ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure isindex( cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL );
procedure linkRel( crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL );
procedure linkRev( crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL );
procedure meta( chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2 );
-----------

-----------     BODY TAGS
procedure line( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure hr( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure nl( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure br( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure header( nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure anchor( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure anchor2( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure mailto( caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2,
  cattributes IN VARCHAR2 default NULL );
procedure img( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure img2( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL,
  cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure para;
procedure paragraph( calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure address( cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure Comment( ctext IN VARCHAR2 );
procedure preOpen( cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure preClose;
procedure blockquoteOpen( cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure blockquoteClose;
procedure area( ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL,
  chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure mapOpen( cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure mapClose;
procedure bgsound( csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure div( calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure listingOpen;
procedure listingClose;
procedure nobr( ctext IN VARCHAR2 );
procedure wbr;
procedure center( ctext IN VARCHAR2 );
procedure centerOpen;
procedure centerClose;
procedure dfn(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure big( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure small( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure sub( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure sup( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure baseFont(nsize IN INTEGER, cattributes IN VARCHAR2 default NULL);
procedure fontOpen( ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL );
procedure fontClose;
procedure plaintext( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure s( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure strike( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

--------- FRAME TAGS
procedure framesetOpen( crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure framesetClose;
procedure frame( csrc IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL,
  cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure noframeOpen;
procedure noframeClose;

--------- LIST TAGS
procedure listHeader( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure listItem( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure ulistOpen( cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure ulistClose;
procedure olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure olistClose;
procedure dlistOpen( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure dlistClose;
procedure dlistDef( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL );
procedure menulistOpen;
procedure menulistClose;
procedure dirlistOpen;
procedure dirlistClose;

---------	CHARACTER FORMAT TAGS
procedure cite( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure code( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure emphasis( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure em( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure keyboard( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure kbd( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure sample( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure strong( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure variable( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

---------	PHYSICAL FORMAT TAGS
procedure bold( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure italic( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure teletype( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

---------	FORM TAGS
procedure formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST',
  ctarget IN VARCHAR2 default NULL, cenctype IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formClose;
procedure formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON',
  cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formFile(cname IN VARCHAR2, caccept IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formPassword(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2, cchecked IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formReset(cvalue IN VARCHAR2 default 'Reset', cattributes IN VARCHAR2 default NULL);
procedure formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'Submit',
  cattributes IN VARCHAR2 default NULL);
procedure formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formSelectOpen(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL);
procedure formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formSelectClose;
procedure formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextAreaClose;

---------	TABLE TAGS
procedure tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure tableClose;
procedure tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure tableRowClose;
procedure tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);
procedure tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL);

end HTP;
/
create or replace
package body HTP AS
-----------	PRINT PROCEDURES
procedure print(cbuf IN VARCHAR2) IS
begin
	prn(htf.print(cbuf));
end print;
procedure p(cbuf IN VARCHAR2) IS
begin
	prn(htf.p(cbuf));
end p;
procedure prn(cbuf IN VARCHAR2) IS
begin
	oci_www.putString(cbuf);
end prn;
procedure prints(cbuf IN VARCHAR2) IS
begin
	prn( htf.prints(cbuf));
end prints;
procedure ps(cbuf IN VARCHAR2) IS
begin
	prn( htf.ps(cbuf));
end ps;
-----------
-----------	 STRUCTURE TAGS
procedure htmlOpen IS
begin
	prn(htf.htmlOpen);
end htmlOpen;
procedure htmlClose IS
begin
	prn(htf.htmlClose);
end htmlClose;
procedure headOpen IS
begin
	prn(htf.headOpen);
end headOpen;
procedure headClose IS
begin
	prn(htf.headClose);
end headClose;
procedure bodyOpen(cbackground IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.bodyOpen(cbackground,cattributes));
end bodyOpen;
procedure bodyClose IS
begin
	prn(htf.bodyClose);
end bodyClose;
----------
----------	HEAD RELATED TAGS
procedure title(ctitle IN VARCHAR2) IS
begin
	prn(htf.title(ctitle));
end title;
procedure base(ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.base(ctarget,cattributes));
end base;
procedure isindex(cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL) IS
begin
	prn(htf.isindex(cprompt,curl));
end isindex;
procedure linkRel(crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL) IS
begin
	prn(htf.linkRel(crel,curl,ctitle));
end linkRel;
procedure linkRev(crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL) IS
begin
	prn(htf.linkRev(crev,curl,ctitle));
end linkRev;
procedure meta(chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2) IS
begin
	prn(htf.meta(chttp_equiv,cname,ccontent));
end meta;
--------	 BODY TAGS
procedure line(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.line(cclear,csrc,cattributes));
end line;
procedure hr(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.hr(cclear,csrc,cattributes));
end hr;
procedure nl(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.nl(cclear,cattributes));
end nl;
procedure br(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.br(cclear,cattributes));
end br;
procedure header(nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.header(nsize,cheader,calign,cnowrap,cclear,cattributes));
end header;
procedure anchor(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.anchor(curl,ctext,cname,cattributes));
end anchor;
procedure anchor2(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.anchor2(curl,ctext,cname,ctarget,cattributes));
end anchor2;
procedure mailto(caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.mailto(caddress,ctext,cattributes));
end mailto;
procedure img(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.img(curl,calign,calt,cismap,cattributes));
end img;
procedure img2(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.img2(curl,calign,calt,cismap,cattributes));
end img2;
procedure para IS
begin
	prn(htf.para);
end para;
procedure paragraph(calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.paragraph(calign,cnowrap,cclear,cattributes));
end paragraph;
procedure address(cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL,
  cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.address(cvalue,cnowrap,cclear,cattributes));
end address;
procedure Comment(ctext IN VARCHAR2) IS
begin
	prn(htf.comment(ctext));
end Comment;
procedure preOpen(cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.preOpen(cclear,cwidth,cattributes));
end preOpen;
procedure preClose IS
begin
	prn(htf.preClose);
end preClose;
procedure blockquoteOpen(cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.blockquoteOpen(cnowrap,cclear,cattributes));
end blockquoteOpen;
procedure blockquoteClose IS
begin
	prn(htf.blockquoteClose);
end blockquoteClose;
procedure area(ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL,
  chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL,
  ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.area(ccoords,cshape,chref,cnohref,ctarget,cattributes));
end area;
procedure mapOpen(cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.mapOpen(cname,cattributes));
end mapOpen;
procedure mapClose IS
begin
	prn(htf.mapClose);
end mapClose;
procedure bgsound(csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.bgsound(csrc,cloop,cattributes));
end bgsound;
procedure div(calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.div(calign,cattributes));
end div;
procedure listingOpen IS
begin
	prn(htf.listingOpen);
end listingOpen;
procedure listingClose IS
begin
	prn(htf.listingClose);
end listingClose;
procedure nobr(ctext IN VARCHAR2) IS
begin
	prn(htf.nobr(ctext));
end nobr;
procedure wbr IS
begin
	prn(htf.wbr);
end wbr;
procedure center(ctext IN VARCHAR2) IS
begin
	prn(htf.center(ctext));
end center;
procedure centerOpen IS
begin
	prn(htf.centerOpen);
end centerOpen;
procedure centerClose IS
begin
	prn(htf.centerClose);
end centerClose;
procedure dfn(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.dfn(ctext,cattributes));
end dfn;
procedure big(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.big(ctext,cattributes));
end big;
procedure small(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.small(ctext,cattributes));
end small;
procedure sub(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.sub(ctext,calign,cattributes));
end sub;
procedure sup(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.sup(ctext,calign,cattributes));
end sup;
procedure baseFont(nsize IN INTEGER, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.baseFont(nsize,cattributes));
end baseFont;
procedure fontOpen(ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.fontOpen(ccolor,cface,nsize,cattributes));
end fontOpen;
procedure fontClose IS
begin
	prn(htf.fontClose);
end fontClose;
procedure plaintext(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.plaintext(ctext,cattributes));
end plaintext;
procedure s(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.s(ctext,cattributes));
end s;
procedure strike(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.strike(ctext));
end strike;
---------------
---------------	FRAME TAGS
procedure framesetOpen(crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.framesetOpen(crows,ccols,cattributes));
end framesetOpen;
procedure framesetClose IS
begin
	prn(htf.framesetClose);
end framesetClose;
procedure frame(csrc IN VARCHAR2, cname IN VARCHAR2 default NULL,
  cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL,
  cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.frame(csrc,cname,cmarginwidth,cmarginheight,cscrolling,cnoresize,cattributes));
end frame;
procedure noframeOpen IS
begin
	prn(htf.noframeOpen);
end noframeOpen;
procedure noframeClose IS
begin
	prn(htf.noframeClose);
end noframeClose;
-----------------
-----------------	LIST TAGS
procedure listHeader(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.listHeader(ctext,cattributes));
end listHeader;
procedure listItem(ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.listItem(ctext,cclear,cdingbat,cattributes));
end listItem;
procedure ulistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.ulistOpen(cclear,cwrap,cdingbat,csrc,cattributes));
end ulistOpen;
procedure ulistClose IS
begin
	prn(htf.ulistClose);
end ulistClose;
procedure olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.olistOpen(cclear,cwrap,cattributes));
end olistOpen;
procedure olistClose IS
begin
	prn(htf.olistClose);
end olistClose;
procedure dlistOpen(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.dlistOpen(cclear,cattributes));
end dlistOpen;
procedure dlistClose IS
begin
	prn(htf.dlistClose);
end dlistClose;
procedure dlistDef(ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.dlistDef(ctext,cclear,cattributes));
end dlistDef;
procedure dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.dlistTerm(ctext,cclear,cattributes));
end dlistTerm;
procedure menulistOpen IS
begin
	prn(htf.menulistOpen);
end menulistOpen;
procedure menulistClose IS
begin
	prn(htf.menulistClose);
end menulistClose;
procedure dirlistOpen IS
begin
	prn(htf.dirlistOpen);
end dirlistOpen;
procedure dirlistClose IS
begin
	prn(htf.dirlistClose);
end dirlistClose;
---------	CHARACTER FORMAT TAGS
procedure cite(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.cite(ctext,cattributes));
end cite;
procedure code(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.code(ctext,cattributes));
end code;
procedure emphasis(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.emphasis(ctext,cattributes));
end emphasis;
procedure em(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.em(ctext,cattributes));
end em;
procedure keyboard(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.keyboard(ctext,cattributes));
end keyboard;
procedure kbd(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.kbd(ctext,cattributes));
end kbd;
procedure sample(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.sample(ctext,cattributes));
end sample;
procedure strong(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.strong(ctext,cattributes));
end strong;
procedure variable(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.variable(ctext,cattributes));
end variable;
---------
---------	PHYSICAL FORMAT TAGS
procedure bold(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.bold(ctext,cattributes));
end bold;
procedure italic(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.italic(ctext,cattributes));
end italic;
procedure teletype(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.teletype(ctext,cattributes));
end teletype;
---------	FORM TAGS
procedure formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST',
  ctarget IN VARCHAR2 default NULL, cenctype IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formOpen(curl,cmethod,ctarget,cenctype,cattributes));
end formOpen;
procedure formClose IS
begin
	prn(htf.formClose);
end formClose;
procedure formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON',
  cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formCheckbox(cname,cvalue,cchecked,cattributes));
end formCheckBox;
procedure formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formHidden(cname,cvalue,cattributes));
end formHidden;
procedure formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formImage(cname,csrc,calign,cattributes));
end formImage;
procedure formFile(cname IN VARCHAR2, caccept IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formFile(cname,caccept,cattributes));
end;
procedure formPassword(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formPassword(cname,csize,cmaxlength,cvalue,cattributes));
end formPassword;
procedure formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2,
  cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formRadio(cname,cvalue,cchecked,cattributes));
end formRadio;
procedure formReset(cvalue IN VARCHAR2 default 'Reset',
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formReset(cvalue,cattributes));
end formReset;
procedure formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'Submit',
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formSubmit(cname,cvalue,cattributes));
end formSubmit;
procedure formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL,
  cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formText(cname,csize,cmaxlength,cvalue,cattributes));
end formText;
procedure formSelectOpen(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL,
  nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formSelectOpen(cname,cprompt,nsize,cattributes));
end formSelectOpen;
procedure formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formSelectOption(cvalue,cselected,cattributes));
end formSelectOption;
procedure formSelectClose IS
begin
	prn(htf.formSelectClose);
end formSelectClose;
procedure formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formTextArea(cname,nrows,ncolumns,calign,cattributes));
end formTextArea;
procedure formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formTextArea2(cname,nrows,ncolumns,calign,cwrap,cattributes));
end formTextArea2;
procedure formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formTextAreaOpen(cname,nrows,ncolumns,calign,cattributes));
end formTextAreaOpen;
procedure formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER,
  calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.formTextAreaOpen2(cname,nrows,ncolumns,calign,cwrap,cattributes));
end formTextAreaOpen2;
procedure formTextAreaClose IS
begin
	prn(htf.formTextAreaClose);
end formTextAreaClose;
--------- 	TABLE TAGS
procedure tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.tableOpen(cborder,calign,cnowrap,cclear,cattributes));
end tableOpen;
procedure tableClose IS
begin
	prn(htf.tableClose);
end tableCLose;
procedure tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.tableCaption(ccaption,calign,cattributes));
end tableCaption;
procedure tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.tableRowOpen(calign,cvalign,cdp,cnowrap,cattributes));
end tableRowOpen;
procedure tableRowClose IS
begin
	prn(htf.tableRowClose);
end tableRowClose;
procedure tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.tableHeader(cvalue,calign,cdp,cnowrap,crowspan,ccolspan,cattributes));
end tableHeader;
procedure tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL,
  cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL,
  crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL,
  cattributes IN VARCHAR2 default NULL) IS
begin
	prn(htf.tableData(cvalue,calign,cdp,cnowrap,crowspan,ccolspan,cattributes));
end tableData;
end HTP;
/
drop public synonym htp;
create public synonym htp for htp;
grant execute on htp to public;

drop public synonym htf;
create public synonym htf for htf;
grant execute on htf to public;

