set escape on
create or replace package HTP
as

-----------     PRINT PROCEDURES
procedure print( cbuf IN VARCHAR2 );
procedure p( cbuf IN VARCHAR2 );
procedure prn( cbuf IN VARCHAR2 );
procedure prints( cbuf IN VARCHAR2 );
procedure ps( cbuf IN VARCHAR2 );
-----------

-----------     STRUCTURE TAGS
procedure htmlOpen;
procedure htmlClose;
procedure headOpen;
procedure headClose;
procedure bodyOpen( cbackground IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure bodyClose;
-----------

-----------     HEAD RELATED TAGS
procedure title( ctitle IN VARCHAR2 );
procedure base( ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure isindex( cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL );
procedure linkRel( crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL );
procedure linkRev( crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL );
procedure meta( chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2 );
-----------

-----------     BODY TAGS
procedure line( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure hr( cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure nl( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure br( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure header( nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure anchor( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure anchor2( curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL, ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure mailto( caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure img( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure img2( curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure para;
procedure paragraph( calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure address( cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure Comment( ctext IN VARCHAR2 );
procedure preOpen( cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure preClose;
procedure blockquoteOpen( cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure blockquoteClose;
procedure area( ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL, chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL, ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure mapOpen( cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure mapClose;
procedure bgsound( csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure div( calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure listingOpen;
procedure listingClose;
procedure nobr( ctext IN VARCHAR2 );
procedure wbr;
procedure center( ctext IN VARCHAR2 );
procedure centerOpen;
procedure centerClose;
procedure dfn( ctext IN VARCHAR2 );
procedure big( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure small( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure sub( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure sup( ctext IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure baseFont( nsize IN INTEGER );
procedure fontOpen( ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL, nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL );
procedure fontClose;
procedure plaintext( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure s( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure strike( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

--------- FRAME TAGS
procedure framesetOpen( crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure framesetClose;
procedure frame( csrc IN VARCHAR2, cname IN VARCHAR2 default NULL, cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL, cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure noframeOpen;
procedure noframeClose;

--------- LIST TAGS
procedure listHeader( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure listItem( ctext IN VARCHAR2, cclear IN VARCHAR2 default NULL, cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure ulistOpen( cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure ulistClose;
procedure olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure olistClose;
procedure dlistOpen( cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure dlistClose;
procedure dlistDef( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL );
procedure menulistOpen;
procedure menulistClose;
procedure dirlistOpen;
procedure dirlistClose;

---------	CHARACTER FORMAT TAGS
procedure cite( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure code( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure emphasis( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure em( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure keyboard( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure kbd( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure sample( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure strong( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure variable( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

---------	PHYSICAL FORMAT TAGS
procedure bold( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure italic( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );
procedure teletype( ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL );

---------	FORM TAGS
procedure formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST', ctarget IN VARCHAR2, cenctype IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formClose;
procedure formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON', cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON', cattributes IN VARCHAR2 default NULL);
procedure formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formPassword(cname IN VARCHAR2, csize IN VARCHAR2, cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2, cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formReset(cvalue IN VARCHAR2 default 'RESET', cattributes IN VARCHAR2 default NULL);
procedure formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'SUBMIT', cattributes IN VARCHAR2 default NULL);
procedure formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL, cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formOpenSelect(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL, nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL);
procedure formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,cattributes IN VARCHAR2 default NULL);
procedure formSelectClose;
procedure formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure formTextAreaClose;

---------	TABLE TAGS
procedure tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure tableClose;
procedure tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure tableRowClose;
procedure tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);
procedure tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL);

end HTP;
/

create or replace package body HTP AS

-----------	PRINT PROCEDURES
procedure print(cbuf IN VARCHAR2) IS
begin
	oci_www.putString(cbuf||CHR(13));
end print;

procedure p(cbuf IN VARCHAR2) IS
begin
	oci_www.putString(cbuf||CHR(13));
end p;

procedure prn(cbuf IN VARCHAR2) IS
begin
	oci_www.putString(cbuf);
end prn;

procedure prints(cbuf IN VARCHAR2) IS
begin
	oci_www.putString( replace( replace( replace( replace(cbuf,'\&','\&amp;'),'<','\&lt;'),'>','\&gt;'), '"', '\&quot;') );
end prints;

procedure ps(cbuf IN VARCHAR2) IS
begin
	oci_www.putString( replace( replace( replace( replace(cbuf,'\&','\&amp;'),'<','\&lt;'),'>','\&gt;'), '"', '\&quot;') );
end ps;
-----------

-----------	 STRUCTURE TAGS
procedure htmlOpen IS
begin
	oci_www.putString('<HTML>');
end htmlOpen;

procedure htmlClose IS
begin
	oci_www.putString('</HTML>');
end htmlClose;

procedure headOpen IS
begin
	oci_www.putString('<HEAD>');
end headOpen;

procedure headClose IS
begin
	oci_www.putString('</HEAD>');
end headClose;

procedure bodyOpen(cbackground IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BODY background="'||cbackground||'" '||cattributes||'>');
end bodyOpen;

procedure bodyClose IS
begin
	oci_www.putString('</BODY>');
end bodyClose;
----------

----------	HEAD RELATED TAGS
procedure title(ctitle IN VARCHAR2) IS
begin
	oci_www.putString('<TITLE>'||ctitle||'</TITLE>');
end title;

procedure base(ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BASE TARGET="'||ctarget||'" HREF="'||cattributes||'">');
end base;

procedure isindex(cprompt IN VARCHAR2 default NULL, curl IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<ISINDEX PROMPT="'||cprompt||'" HREF="'||curl||'">');
end isindex;

procedure linkRel(crel IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('LINK REL="'||crel||'" HREF="'||curl||'" TITLE="'||ctitle||'">');
end linkRel;

procedure linkRev(crev IN VARCHAR2, curl IN VARCHAR2, ctitle IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('LINK REV="'||crev||'" HREF="'||curl||'" TITLE="'||ctitle||'">');
end linkRev;

procedure meta(chttp_equiv IN VARCHAR2, cname IN VARCHAR2, ccontent IN VARCHAR2) IS
begin
	oci_www.putString('<META HTTP-EQUIV="'||chttp_equiv||'" NAME="'||cname||'" CONTENT="'||ccontent||'">');
end meta;

--------	 BODY TAGS
procedure line(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<HR CLEAR="'||cclear||'" SRC="'||csrc||'" '||cattributes||'>');
end line;

procedure hr(cclear IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<HR CLEAR="'||cclear||'" SRC="'||csrc||'" '||cattributes||'>');
end hr;

procedure nl(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BR CLEAR="'||cclear||'" '||cattributes||'>');
end nl;

procedure br(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BR CLEAR="'||cclear||'" '||cattributes||'>');
end br;

procedure header(nsize IN INTEGER, cheader IN VARCHAR2, calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<H'||nsize||' ALIGN="'||calign||'" '||cnowrap||' CLEAR="'||cclear||'" '||cattributes||'>'||cheader||'</H'||nsize||'>');
end header;

procedure anchor(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<A HREF="'||curl||'" NAME="'||cname||'" '||cattributes||'>'||ctext||'</A>');
end anchor;

procedure anchor2(curl IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2 default NULL, ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<A HREF="'||curl||'" NAME="'||cname||'" TARGET="'||ctarget||'" '||cattributes||'>'||ctext||'</A>');
end anchor2;

procedure mailto(caddress IN VARCHAR2, ctext IN VARCHAR2, cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<A HREF="mailto:'||caddress||'" '||cattributes||'>'||ctext||'</A>');
end mailto;

procedure img(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<IMG SRC="'||curl||'" ALIGN="'||calign||'" ALT="'||calt||'" '||cismap||' '||cattributes||'>');
end img;

procedure img2(curl IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, calt IN VARCHAR2 default NULL, cismap IN VARCHAR2 default NULL, cusemap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<IMG SRC="'||curl||'" ALIGN="'||calign||'" ALT="'||calt||'" '||cismap||' USEMAP="'||cusemap||'" '||cattributes||'>');
end img2;

procedure para IS
begin
	oci_www.putString('<P>');
end para;

procedure paragraph(calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<P CLEAR="'||cclear||'" '||cnowrap||' '||cattributes||'>');
end paragraph;

procedure address(cvalue IN VARCHAR2, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<ADDRESS CLEAR="'||cclear||'" '||cnowrap||' '||cattributes||'>'||cvalue||'</ADDRESS>');
end address;

procedure Comment(ctext IN VARCHAR2) IS
begin
	oci_www.putString('<!-- '||ctext||' -->');
end Comment;

procedure preOpen(cclear IN VARCHAR2 default NULL, cwidth IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('PRE CLEAR="'||cclear||'" WIDTH="'||cwidth||'" '||cattributes||'>');
end preOpen;

procedure preClose IS 
begin
	oci_www.putString('</PRE>');
end preClose;

procedure blockquoteOpen(cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BLOCKQUOTE CLEAR="'||cclear||'" '||cnowrap||' '||cattributes||'>');
end blockquoteOpen;

procedure blockquoteClose IS
begin
	oci_www.putString('</DLOCKQUOTE>');
end blockquoteClose;

procedure area(ccoords IN VARCHAR2, cshape IN VARCHAR2 default NULL, chref IN VARCHAR2 default NULL, cnohref IN VARCHAR2 default NULL, ctarget IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('AREA COORDS="'||ccoords||'" SHAPE="'||cshape||'" HREF="'||chref||'" '||cnohref||' TARGET="'||ctarget||'" '||cattributes||'>');
end area;

procedure mapOpen(cname IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<MAP NAME="'||cname||'" '||cattributes||'>');
end mapOpen;

procedure mapClose IS
begin
	oci_www.putString('</MAP>');
end mapClose;

procedure bgsound(csrc IN VARCHAR2, cloop IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<BGSOUND SRC="'||csrc||'" LOOP="'||cloop||'" '||cattributes||'>');
end bgsound;

procedure div(calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<DIV ALIGN="'||calign||'" '||cattributes||'>');
end div;

procedure listingOpen IS
begin
	oci_www.putString('<LISTING>');
end listingOpen;

procedure listingClose IS
begin
	oci_www.putString('</LISTING>');
end listingClose;

procedure nobr(ctext IN VARCHAR2) IS
begin
	oci_www.putString('<NOBR>'||ctext||'</NOBR>');
end nobr;

procedure wbr IS
begin
	oci_www.putString('<WBR>');
end wbr;

procedure center(ctext IN VARCHAR2) IS
begin
	oci_www.putString('<CENTER>'||ctext||'</CENTER>');
end center;

procedure centerOpen IS
begin
	oci_www.putString('<CENTER>');
end centerOpen;

procedure centerClose IS
begin
	oci_www.putString('</CENTER>');
end centerClose;

procedure dfn(ctext IN VARCHAR2) IS
begin
	oci_www.putString('<DFN>'||ctext||'</DFN>');
end dfn;

procedure big(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin 
	oci_www.putString('<BIG '||cattributes||'>'||ctext||'</BIG>');
end big;

procedure small(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin 
	oci_www.putString('<SMALL '||cattributes||'>'||ctext||'</SMALL>');
end small;

procedure sub(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin 
	oci_www.putString('<SUB ALIGN="'||calign||'" '||cattributes||'>'||ctext||'</SUB>');
end sub;

procedure sup(ctext IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin 
	oci_www.putString('<SUP ALIGN="'||calign||'" '||cattributes||'>'||ctext||'</SUP>');
end sup;

procedure baseFont(nsize IN INTEGER) IS
begin
	oci_www.putString('<BASEFONT SIZE="'||nsize||'">');
end baseFont;

procedure fontOpen(ccolor IN VARCHAR2 default NULL, cface IN VARCHAR2 default NULL, nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<FONT COLOR="'||ccolor||'" FACE="'||cface||'" SIZE="'||nsize||'" '||cattributes||'>');
end fontOpen;

procedure fontClose IS
begin
	oci_www.putString('</FONT>');
end fontClose;

procedure plaintext(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<PLAINTEXT '||cattributes||'>'||ctext||'</PLAINTEXT>');
end plaintext;

procedure s(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<S '||cattributes||'>'||ctext||'</S>');
end s;

procedure strike(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<STRIKE '||cattributes||'>'||ctext||'</STRIKE>');
end strike;
---------------

---------------	FRAME TAGS
procedure framesetOpen(crows IN VARCHAR2 default NULL, ccols IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<FRAMESET ROWS="'||crows||'" COLS="'||ccols||'" '||cattributes||'>');
end framesetOpen;

procedure framesetClose IS
begin
	oci_www.putString('</FRAMESET>');
end framesetClose;

procedure frame(csrc IN VARCHAR2, cname IN VARCHAR2 default NULL, cmarginwidth IN VARCHAR2 default NULL, cmarginheight IN VARCHAR2 default NULL, cscrolling IN VARCHAR2 default NULL, cnoresize IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<FRAME SRC="'||csrc||'" NAME="'||cname||'" MARGINWIDTH="'||cmarginwidth||'" MARGINHEIGHT="'||cmarginheight||'" SCROLLING="'||cscrolling||'" '||cnoresize||' '||cattributes||'>');
end frame;

procedure noframeOpen IS
begin 
	oci_www.putString('<NOFRAMES>');
end noframeOpen;

procedure noframeClose IS
begin 
	oci_www.putString('</NOFRAMES>');
end noframeClose;
-----------------

-----------------	LIST TAGS
procedure listHeader(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<LH '||cattributes||'>'||ctext||'</LH>');
end listHeader;

procedure listItem(ctext IN VARCHAR2, cclear IN VARCHAR2 default NULL, cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<LI CLEAR="'||cclear||'" DINGBAT="'||cdingbat||'" SCR="'||csrc||'" '||cattributes||'>'||ctext);
end listItem;

procedure ulistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cdingbat IN VARCHAR2 default NULL, csrc IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<UL CLEAR="'||cclear||'" WRAP="'||cwrap||'" DINGBAT="'||cdingbat||'" SRC="'||csrc||'" '||cattributes||'>');
end ulistOpen;

procedure ulistClose IS
begin
	oci_www.putString('</UL>');
end ulistClose;

procedure olistOpen(cclear IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<OL CLEAR="'||cclear||'" WRAP="'||cwrap||'" '||cattributes||'>');
end olistOpen;

procedure olistClose IS
begin
	oci_www.putString('</OL>');
end olistClose;

procedure dlistOpen(cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<DL CLEAR="'||cclear||'" '||cattributes||'>');
end dlistOpen;

procedure dlistClose IS
begin
	oci_www.putString('</DL>');
end dlistClose;

procedure dlistDef(ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<DD CLEAR="'||cclear||'" '||cattributes||'>'||ctext);
end dlistDef;

procedure dlistTerm( ctext IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<DT CLEAR="'||cclear||'" '||cattributes||'>'||ctext);
end dlistTerm;

procedure menulistOpen IS
begin
	oci_www.putString('<MENU>');
end menulistOpen;

procedure menulistClose IS
begin
	oci_www.putString('</MENU>');
end menulistClose;

procedure dirlistOpen IS
begin
	oci_www.putString('<DIR>');
end dirlistOpen;

procedure dirlistClose IS
begin
	oci_www.putString('</DIR>');
end dirlistClose;

---------	CHARACTER FORMAT TAGS
procedure cite(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<CITE '||cattributes||'>'||ctext||'</CITE>');
end cite;

procedure code(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<CODE '||cattributes||'>'||ctext||'</CODE>');
end code;

procedure emphasis(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<EM '||cattributes||'>'||ctext||'</EM>');
end emphasis;

procedure em(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<EM '||cattributes||'>'||ctext||'</EM>');
end em;

procedure keyboard(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<KBD '||cattributes||'>'||ctext||'</KBD>');
end keyboard;

procedure kbd(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<KBD '||cattributes||'>'||ctext||'</KBD>');
end kbd;

procedure sample(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<SAMP '||cattributes||'>'||ctext||'</SAMP>');
end sample;

procedure strong(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<STRONG '||cattributes||'>'||ctext||'</STRONG>');
end strong;

procedure variable(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<VAR '||cattributes||'>'||ctext||'</VAR>');
end variable;
---------

---------	PHYSICAL FORMAT TAGS
procedure bold(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<B '||cattributes||'>'||ctext||'</B>');
end bold;

procedure italic(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<I '||cattributes||'>'||ctext||'</I>');
end italic;

procedure teletype(ctext IN VARCHAR2, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TT '||cattributes||'>'||ctext||'</TT>');
end teletype;

---------	FORM TAGS
procedure formOpen(curl IN VARCHAR2, cmethod IN VARCHAR2 default 'POST', ctarget IN VARCHAR2, cenctype IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<FORM ACTION="'||curl||'" METHOD="'||cmethod||'" TARGET="'||ctarget||'" ENCTYPE="'||cenctype||'" '||cattributes||'>');
end formOpen;

procedure formClose IS
begin
	oci_www.putString('</FORM>');
end formClose;

procedure formCheckbox(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON', cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="checkbox" NAME="'||cname||'" VALUE="'||cvalue||'" '||cchecked||' '||cattributes||'>');
end formCheckBox;

procedure formHidden(cname IN VARCHAR2, cvalue IN VARCHAR2 default 'ON', cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="hidden" NAME="'||cname||'" VALUE="'||cvalue||'" '||cattributes||'>');
end formHidden;

procedure formImage(cname IN VARCHAR2, csrc IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="image" NAME="'||cname||'" SRC="'||csrc||'" ALIGN="'||calign||'" '||cattributes||'>');
end formImage;

procedure formPassword(cname IN VARCHAR2, csize IN VARCHAR2, cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="password" NAME="'||cname||'" SIZE="'||csize||'" MAXLENGTH="'||cmaxlength||'" VALUE="'||cvalue||'" '||cattributes||'>');
end formPassword;

procedure formRadio(cname IN VARCHAR2, cvalue IN VARCHAR2, cchecked IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="radio" NAME="'||cname||'" VALUE="'||cvalue||'" '||cchecked||' '||cattributes||'>');
end formRadio;

procedure formReset(cvalue IN VARCHAR2 default 'RESET', cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="reset" VALUE="'||cvalue||'" '||cattributes||'>');
end formReset;

procedure formSubmit(cname IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default 'SUBMIT', cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="submit" NAME="'||cname||'" VALUE="'||cvalue||'" '||cattributes||'>');
end formSubmit;

procedure formText(cname IN VARCHAR2, csize IN VARCHAR2 default NULL, cmaxlength IN VARCHAR2 default NULL, cvalue IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="text" NAME="'||cname||'" VALUE="'||cvalue||'" SIZE="'||csize||'" MAXLENGTH="'||cmaxlength||'" '||cattributes||'>');
end formText;

procedure formOpenSelect(cname IN VARCHAR2, cprompt IN VARCHAR2 default NULL, nsize IN INTEGER default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<INPUT TYPE="radio" NAME="'||cname||'" PROMPRT="'||cprompt||'" SIZE="'||nsize||'" '||cattributes||'>');
end formOpenSelect;

procedure formSelectOption(cvalue IN VARCHAR2, cselected IN VARCHAR2 default NULL,cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<OPTION '||cselected||' '||cattributes||'>'||cvalue);
end formSelectOption;

procedure formSelectClose IS
begin
	oci_www.putString('</SELECT>');
end formSelectClose;

procedure formTextArea(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TEXTAREA NAME="'||cname||'" ROWS="'||nrows||'" COLS="'||ncolumns||'" ALIGN="'||calign||'" '||cattributes||'></TEXTAREA>');
end formTextArea;

procedure formTextArea2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TEXTAREA NAME="'||cname||'" ROWS="'||nrows||'" COLS="'||ncolumns||'" WRAP="'||cwrap||'" ALIGN="'||calign||'" '||cattributes||'></TEXTAREA>');
end formTextArea2;

procedure formTextAreaOpen(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TEXTAREA NAME="'||cname||'" ROWS="'||nrows||'" COLS="'||ncolumns||'" ALIGN="'||calign||'" '||cattributes||'>');
end formTextAreaOpen;

procedure formTextAreaOpen2(cname IN VARCHAR2, nrows IN INTEGER, ncolumns IN INTEGER, calign IN VARCHAR2 default NULL, cwrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TEXTAREA NAME="'||cname||'" ROWS="'||nrows||'" COLS="'||ncolumns||'" WRAP="'||cwrap||'" ALIGN="'||calign||'" '||cattributes||'>');
end formTextAreaOpen2;

procedure formTextAreaClose IS
begin
	oci_www.putString('</TEXTAREA>');
end formTextAreaClose;

--------- 	TABLE TAGS
procedure tableOpen(cborder IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cclear IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin 
	oci_www.putString('<TABLE BORDER="'||cborder||'" '||cnowrap||' ALIGN="'||calign||'" CLEAR="'||cclear||'" '||cattributes||'>');
end tableOpen;

procedure tableClose IS
begin
	oci_www.putString('</TABLE>');
end tableCLose;

procedure tableCaption(ccaption IN VARCHAR2, calign IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<CAPTION ALIGN="'||calign||'" '||cattributes||'>'||ccaption||'</CAPTION>');
end tableCaption;

procedure tableRowOpen(calign IN VARCHAR2 default NULL, cvalign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TR ALIGN="'||calign||'" VALIGN="'||cvalign||'" DP="'||cdp||'" '||cnowrap||' '||cattributes||'>');
end tableRowOpen;

procedure tableRowClose IS
begin
	oci_www.putString('</TR>');
end tableRowClose;

procedure tableHeader(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TH ALIGN="'||calign||'" DP="'||cdp||'" ROWSPAN="'||crowspan||'" COLSPAN="'||ccolspan||'" '||cnowrap||' '||cattributes||'></TH>');
end tableHeader;

procedure tableData(cvalue IN VARCHAR2 default NULL, calign IN VARCHAR2 default NULL, cdp IN VARCHAR2 default NULL, crowspan IN VARCHAR2 default NULL, ccolspan IN VARCHAR2 default NULL, cnowrap IN VARCHAR2 default NULL, cattributes IN VARCHAR2 default NULL) IS
begin
	oci_www.putString('<TD ALIGN="'||calign||'" DP="'||cdp||'" ROWSPAN="'||crowspan||'" COLSPAN="'||ccolspan||'" '||cnowrap||' '||cattributes||'></TD>');
end tableData;

end HTP;
/
show errors

drop public synonym htp;
create public synonym htp for htp;
grant execute on htp to public;

