CREATE OR REPLACE PACKAGE owa_sec AS
    PROCEDURE set_protection_realm(realm IN VARCHAR2);
    FUNCTION get_user_id RETURN VARCHAR2;
    FUNCTION get_password RETURN VARCHAR2;
	PROCEDURE clear_credentials;
	PRAGMA restrict_references(get_user_id,WNDS);
	PRAGMA restrict_references(get_password,WNDS);
	PRAGMA restrict_references(set_protection_realm,WNDS);
END owa_sec;
/
show err

CREATE OR REPLACE PACKAGE BODY owa_sec AS
	PROCEDURE clear_credentials IS
	BEGIN
		oci_www.UserID:=NULL;
		oci_www.UserPWD:=NULL;
	END clear_credentials;
    PROCEDURE set_protection_realm(realm IN VARCHAR2) IS
    BEGIN
		oci_www.AuthRealm:=realm;
    END set_protection_realm;
    FUNCTION get_user_id RETURN VARCHAR2 IS
    BEGIN
		RETURN oci_www.UserID;
    END get_user_id;
    FUNCTION get_password RETURN VARCHAR2 IS
    BEGIN
		RETURN oci_www.UserPWD;
    END get_password;
END;
/
show err
drop public synonym owa_sec;
create public synonym owa_sec for owa_sec;
grant execute on owa_sec to public;
