CREATE OR REPLACE PACKAGE owa_util AS
    TYPE ident_arr IS TABLE OF VARCHAR2(2000);
    PROCEDURE redirect_url(loc IN VARCHAR2);
    FUNCTION  GET_CGI_ENV(param_name IN VARCHAR2) RETURN VARCHAR2;
    FUNCTION  uri_encode(str IN varchar2) RETURN VARCHAR2;
END owa_util;
/
show errors
CREATE OR REPLACE PACKAGE BODY owa_util AS
    PROCEDURE redirect_url(loc IN VARCHAR2) IS
    BEGIN
	OCI_WWW.PutStringHdr('Location: '||loc);
	OCI_WWW.PutStringHdr('Status: 302');
    END;
    FUNCTION  GET_CGI_ENV(param_name IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
	RETURN oci_www.getEnv(param_name);
    END GET_CGI_ENV;
    FUNCTION  uri_encode(str IN varchar2) RETURN VARCHAR2
    IS
        letter VARCHAR2(3);
		ascii_lt NUMBER;
        newstring VARCHAR2(32000);
        n NUMBER;
    BEGIN
        n:=1;
        LOOP
			letter:=SUBSTR(str,n,1);
			ascii_lt:=ascii(letter);
			IF letter=' ' THEN
				letter:='+';
			ELSIF (ascii_lt NOT BETWEEN ASCII('a') AND ASCII('z'))  
	        	AND (ascii_lt NOT BETWEEN ASCII('A') AND ASCII('Z')) 
	        	AND (ascii_lt NOT BETWEEN ASCII('0') AND ASCII('9')) AND letter!='_' THEN
				letter:='%'||ltrim(to_char(ascii_lt,'0X'));
	    	END IF;
			newstring:=newstring||letter;
	    	n:=n+1;
	    	EXIT WHEN n>LENGTH(str);
		END LOOP;		
        RETURN newstring;
    END uri_encode;
END owa_util;
/
show errors

drop public synonym owa_util;
create public synonym owa_util for owa_util;
grant execute on owa_util to public;
